param($file=$(read-host "filename of psr-zip or psr-mht file? "))   

function writefile($dir, $fname, $text) 
{     
	$text | out-file -append $dir\$fname -Encoding "default"
}   

function convertJPG($dir) 
{   
	$jpgfiles = get-item $dir\*.jpeg.txt 
	foreach($jpg in $jpgfiles)     
	{         
		$filename = $jpg.name.tostring()
	        "$filename -> $($filename.substring(0,$filename.length-4))"
	        [System.Convert]::FromBase64String((Get-Content $jpg -readcount 0)) | set-content -Encoding Byte "$dir\$($filename.substring(0,$filename.length-4))"        
		remove-item $dir\$filename -force    
	}    
}   

function extractPSR($zipfile, $destfolder) 
{  
	$shellApplication = new-object -com shell.application  
	$zip = $shellApplication.Namespace($zipfile)  
	$dest = $shellApplication.Namespace($destfolder)  
	$dest.copyhere($zip.Items()) 
} 

if(test-path $file) 
{ 
	$file = get-item $file  
	$folder = (get-date -Format "yyyyMMddHHmmss").tostring() 
	$folderObject = new-item $folder -type directory -force
	$filename = ""  
	
	if($file.name.tostring().tolower().endswith(".zip")) 
	{  
		$unzipdest = "$($folderobject.fullname.tostring())\temp" 
		new-item $unzipdest -type directory -force | out-null 
		extractPSR $file.fullname $unzipdest 
		$psrfile = get-item "$unzipdest\*.mht"
	} 
	else 
	{  
		$psrfiles = $file
	}   
	
	$content = get-content $psrfile  

	"Start: creating files in folder $pwd\$folder"  
	
	foreach($line in $content) 
	{   
		switch -wildcard ($line)   
		{     
			"Content-Location: *"    
			{         
				#$line         
				$filename = $line.split(":")[1].trim()          
				if($filename.tolower().endswith(".jpeg"))          
				{             
					"writing: $filename.txt"         
				}          
				else          
				{             
					"writing: $filename"         
				}           
				break;     
			}     
			
			"--=_NextPart_*" 
			{ break; }       
			
			"Content-Type: *" 
			{ break; }       

			"Content-Transfer-Encoding: base64" 
			{ break; }       
			
			default     
			{         
				if($filename -ne "")         
				{             
					if($filename.tolower().endswith(".jpeg"))             
					{                 
						if($line -ne "")                 
						{                     
							writefile $folder "$filename.txt" $line                
						}             
					}             
					else             
					{                   
						writefile $folder $filename $line            
					}         
				}         
				break     
			}     
		}   
	} 
"Finished: Creating files""Start: converting pictures from text to JPG"  
convertJPG $folder

"Finished: converting pictures"  

$yesno = read-host "Open containing folder? [y] "  

if($yesno -eq "" -or $yesno.tolower() -eq "y") 
{     
	&explorer.exe $pwd\$folder 
} 

} 
else {     "ERROR: $pwd\$file not found"} 
